%ext ck4
%version 1.4
%egahead EGAHEAD.CK4		# Load the modified graphics
%patchfile $249C2 Keen4.tli 	# for Keen 4


#Keenwave patch file; Patch sounds Keen 4:
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary


#%patch $E56E $EB $12		#Keen can always shoot, don't lose ammo
#%patch $7A40 $EB #disable boss cheat

#BwB levels: all levels above 20
%patch $60FD $14 $77

%patch $1F126 "Bridge" $00 #20
%patch $0FB0B "Kylie enters the Bridge" $00 #20


#Allow 24 levels in Keen 4 v1.4:

#First increase the number of levels we can access from the map to maximum (+6)

%patch $DF5D $18 
#Number of levels enterable ($18 = 24)

%patch $8CA4 $18 #Number of level song entries (24, see below)
#Give extra levels valid stuff:
#Level name pointers:

%patch $30764 $1F040000RL #Map
              $1F050000RL #Level 1
              $1F060000RL #Level 2
              $1F070000RL #Level 3
              $1F090000RL #Level 4...
              $1F0B0000RL
              $1F0C0000RL
              $1F0D0000RL
              $1F0E0000RL
              $1F0F0000RL
              $1F100000RL
              $1F110000RL
              $1F130000RL
              $1F150000RL
              $1F180000RL
              $1F1A0000RL
              $1F1B0000RL
              $1F1C0000RL
              $1F1D0000RL #Bwb Rocket
              $1F1C0000RL #Hall of fame
              $1F120006RL
              $1F1D0000RL #Bwb 2
              $1F1C0000RL
              $1F1C0000RL
              $1F1C0000RL

#Level entrance text pointers

%patch $307C8 $1F1F0000RL #Map
              $1F210000RL #Level 1
              $1F240000RL #Level 2
              $1F260000RL #Level 3...
              $1F290000RL #4
              $1F2D0000RL #5
              $1F300000RL #6
              $1F330000RL #7
              $1F350000RL #8
              $1F380000RL #9
              $1F3A0000RL #10
              $1F3D0000RL #11
              $1F400000RL #12
              $1F430000RL #13
              $1F470000RL #14
              $1F4B0000RL #15
              $1F4E0000RL #16
              $1F510000RL #17
              $1F540000RL #Bwb Rocket
              $1F510000RL #Hall of fame

              $0FA8008BRL #New Lvl1
              $1F540000RL #Bwb 2
              $1F510000RL
              $1F510000RL
              $1F510000RL

#########
# Music #
#########
#0 ohne dich
#1 bitte bitte
#2 walkampf
#3 deichkind
#4 1000 Jahre

%patch $2F206 $0000W  #Map (Shadowlands) 0
              $0002W  #Border Village (Kick in the Pants) 1
              $0003W  #Chemistry Lab 2
              $0004W  #Reactor 3
              $0001W  #Trogg Pod 4
              $0003W  #Weaponary 5
              $0003W  #Factory 6
              $0002W  #Swomp 7
              $0003W  #3 Towers 8
              $0002W  #Mountain 9
              $0001W  #Hidden Bunker 10
              $0004W  #Vulcano 11
              $0002W  #Trogg Village 12
              $0001W  #Hills 13
              $0003W  #Secret Lab 14
              $0003W  #Radar Station 15
              $0002W  #Science Vessel 16
              $0004W  #Space Station 17
              $0004W  #Bwb Megarocket 18
              $FFFFW  #High scores (No music, "Fanfare") 19
              $0002W  #Extra level 1 (No music, "Fanfare") 20
              $0004W  #Extra level 2 (No music, "Fanfare") 21
              $FFFFW  #Extra level 3 (No music, "Fanfare") 22
              $FFFFW  #Extra level 4 (No music, "Fanfare") 23
              $FFFFW  #Extra level 5 (No music, "Fanfare") 24


##################
# Scrolling Text #
##################
#Main menu actions list
%patch $3CB9 $0448W #3C18: Terminator sequence and title screen
             $045FW #3C3C: Star wars story
             $046CW #3C51: High score demo
             $0473W #3C3C: Star wars story
             $0481W #3C51: High score demo
             $0488W #3C3C: Star wars story
             $0496W #3C3C: Star wars story
#Keen 4 Demo
%patch $3C2F $33 $C0 $50 $90 $90 $90 $90 $90     $83 $C4 $02 $EB $65 $9A         #Play demo 1
     $03ED18B8RL     $EB $5E $B8 $0001W  $50 $90 $90 $90 $90 $90     $83 $C4 $02 #Story screen\demo 2
             $EB $50 $9A $03ED1D55RL     $EB $49 $B8 $0002W  $50                 #Highscores
     $90 $90 $90 $90 $90     $83 $C4 $02 $EB $3B $33 $FF $B8 $0003W  $50         #Demo 3
     $90 $90 $90 $90 $90     $83 $C4 $02                                         #Demo 4

# You can make a line break with $0A 
# The story ends at $1F03B, so you can only have a story that's 507 bytes long. 

%patch $1EE40
"Commander Kylie" $0A $0A

"The Terror" $0A
"From Outer Space" $0A $0A

"The asteroids that" $0A
"surround the planet" $0A
"Phaelox are known for" $0A
"their richness in rare" $0A
"Cratom crystals." $0A $0A

"This source was" $0A
"first discovered" $0A
"by the Vorticons" $0A
"who " $0A

%patch $1EF0A
"soon began" $0A
"mining them." $0A  $0A

"Several decades ago," $0A
"with the Cratom source" $0A
"nearly depl" $0A

%patch $1EF59
"eted," $0A
"the Vorticons powered" $0A
"down their equipment" $0A
"and left." $0A $0A

"But now, years later," $0A
"the outpost has once" $0A
"again begun operation." $0A $0A

"The reasons for this" $0A
"are as yet" $0A
"unknown." $0A
$00
#########################
#IF Ammo => Robo Spider #
#########################
%patch $ECA2 $83 $3E $7A60W  $10 $7C $03 $E9 $0151W  $B8 $000BW $50 $FF $76 #Here check Keen's ammo < 5, ammo is 12th item kind
             $FC $57 $9A $037D054DRL     $83 $C4 $06 $8B $1E $D2 $19 $D1 $E3
             $C7 $87 $3B $CB $0001W  $E9 $0132W  $E9 $012FW
%patch $3D1D  $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0009W  $C7 $47 $02 $0001W  $C7 $47 $20 $0000W 
              $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05
              $FF90W  $89 $47 $0C $C7 $47 $0E $0001W  $C7 $47 $10 $0001W  $B8
              $334AW  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#TE Jump
%patch $321BA $0161W $0161W $0003W $000fW $0001W $0008W $00AAW $0000W
              $0FA80AF9RL   $10800530RL   $09DC1795RL    $330EW

#    2ee70                                 
%patch $3217E $015EW $015EW $0003W $000fW $0001W $0008W $00AAW $0000W
              $00000000L   $10800530RL   $09DC1795RL    $332CW			#$332CW
%patch $32188 $00006W     #Animation speed

%patch $3219C $015FW $015FW $0003W $000fW $0001W $0008W $00AAW $0000W
              $00000000L   $10800530RL   $09DC1795RL    $3368W
%patch $321A6 $00006W     #Animation speed

%patch $321D8 $0160W $0160W $0003W $000fW $0001W $0008W $00AAW $0000W
              $00000000L   $10800530RL   $09DC1795RL    $33C2W
%patch $321E2 $00006W      #Animation speed

#Candy Stolen 1
%patch $32232 $0161W $0161W $0003W $000fW $0001W $0008W $00AAW $0000W
              $0FA80103RL   $10800530RL   $09DC1795RL    $330EW         #Randomly changes to Standing
%patch $3223C $00006W      #Animation speed


#New "Miragia animation 5" behavior: $0FA80103RL FA80 + 0103 = FB83
%patch $FB83  $55 $8B $EC $83 $EC $02 $56 $8B $76 $06 $9A $1D02002ARL     $89
              $46 $FE $A1 $4C $A5 $D1 $E0 $D1 $E0 $D1 $E0 $3B $46 $FE $76 $05
              $C7 $44 $1C $3278W  $5E $8B $E5 $5D $CB
#Spider Stand T Smoke
%patch $320E8 $015AW $015AW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $10800530RL   $108002E1RL    $3296W	
%patch $320F2 $0014W 			#Animation Speed

%patch $32106 $015BW $015BW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $10800530RL   $108002E1RL    $32B4W
%patch $32110 $000AW        #Animation speed

%patch $32124 $015CW $015CW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $0FA80CB0RL   $108002E1RL    $251CW
%patch $3212E $0020W        #Animation speed

#Skypest preening 3,4,5
%patch $3138C $015DW $015DW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $0FA80CB0RL   $108002E1RL    $253AW
%patch $31396 $0020W        #Animation speed

%patch $313AA $0162W $0162W $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $0FA80CB0RL   $108002E1RL    $2558W
%patch $313B4 $0020W        #Animation speed

%patch $313C8 $015CW $015CW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $0FA80CB0RL   $108002E1RL    $32D2W
%patch $313D2 $0020W        #Animation speed

#T Smoke 7,8
%patch $32142 $015BW $015BW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $10800530RL   $108002E1RL    $32F0W
%patch $3214C $000AW        #Animation speed

%patch $32160 $015AW $015AW $0003W $000fW $0000W $0008W $0000W $0000W   #Stop Walking
              $0FA80AF9RL   $10800530RL   $108002E1RL    $334AW
%patch $3216A $0014W        #Animation speed



################################
# Treasure Eater => Cave Trogg #
################################
#Treasure Eater foreground values
%patch $11A4C $0000W #Treasure Eater

%patch $306F0 $0151W #Treasure Eater Cache start

#Trog Walk
#TE looks around
%patch $32052 $0152W $0154W $0000W $000fW $0001W $0009W $0078W $0000W
              $11A2022ARL    $10800793RL     $09DC1795RL   $3200W

%patch $32070 $0153W $0155W $0000W $000fW $0001W $0009W $0078W $0000W
              $11A2022ARL    $10800793RL     $09DC1795RL   $31e2W    #$325Aw


#Trog Shoot
#Teleporter smoke 3
%patch $320CA $0156W $0158W $000FW $000fW $000fW $0009W $0000W $0000W
               $0FA80AF9RL    $10800793RL     $09DC176ERL    $33e0W    # Look for Keen

#Teleporter Spark 2-4
%patch $32250 $0157W $0159W $000FW $000fW $000fW $0009W $0000W $0000W
               $108004A4RL    $10800793RL     $09DC176ERL    $33fEW    #Shoot


%patch $3226E $0156W $0158W $000FW $000fW $000fW $0009W $0000W $0000W
               $00000000L    $10800793RL     $09DC176ERL    $341CW #$31e2W


%patch $3228C $0157W $0159W $000FW $000fW $000fW $0009W $0000W $0000W
               $108004A4RL    $10800793RL     $09DC176ERL    $321EW    #Shoot
%patch $32296 $000AW        #Wait before vanishing

#Tele Smoke 1
%patch $3208E $0156W $0158W $000FW $000fW $000fW $0009W $0000W $0000W
               $00000000L    $10800793RL     $09DC176ERL    $31e2W
%patch $32098 $0014W        #Animation speed



#Trog stunned 323C
##Teleporter smoke 2
%patch $320AC $013FW $013FW $0000W $0000W $0000W $0000W $0000W $0000W
              $09DC1701RL   $11A20D86RL    $09DC176ERL    $31e2W   #$3926W
%patch $320B6 $0070W    #Animation speed


#Lindsey 3
%patch $32796 $0151W $0151W $0002W $0000W $0000W $0000W $0000W $0000W 
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W
%patch $327A0 $0034W        #Animation speed



#New "Look for items, teleport to them as a Smirky" behavior: $11A2022ARL 11A20 + 22A = 11C4A
%patch $11C4A  $55 $8B $EC $83 $EC $02 $56 $8B $76 $06 $9A $1D02002ARL     $89
              $46 $FE $A1 $4C $A5 $D1 $E0 $D1 $E0 $D1 $E0 $3B $46 $FE $76 $05
              $C7 $44 $1C $325Aw  $5E $8B $E5 $5D $CB



#New "Inchworm" collision $10800793RL  10800 + 0793 = 10F93 temporaly stun
%patch $10F93 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
         $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E $B8         #If Keen, kill him; check for shot (Type 3)
         $323CW    $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $5F $5E $5D $CB #If shot, become $20
	      
# New Underwater Mine collision: doesn't harm keen, permanent stun Smirky:
# $11A20D86RL     11A20+0D86= 127A6
%patch $127A6  $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $03 $75 $13
               $C7 $44 $16 $0000W  $B8 
               $3926W  $50 $57 $56 $9A $09DC1695RL   $83 $C4 $06 $5F $5E $5D 
               $CB     


#Animation
%patch $321F6 $0163W $0163W #Stunned Treasure Eater in air


################################
# Underwater Mine
################################
%patch $30714 $01B4W #Underwater Mines Cache start
#New Mushroom collision. Stop Bullet don't kill Keen  $0FA804BERL
%patch $FF3E  $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $C7 $4C $83 $3C
              $03 $75 $09 $56 $9A $0D8F0D43RL     $83 $C4 $02 $5F $5E $5D $CB

#Cache
%patch $3075E $01c3W #Underwater Mines cache end
%patch $12720 $0F $00 #Sprite Type Mine now Bounder


%patch $32700 $01BAW $01B8W $0003W $0001W $000AW $0009W $0000W $0000W
              $10800D44RL   $0FA804BERL   $09DC1795RL   $38AEW
%patch $3271E $01c3W $01B9W $0003W $0001W $000AW $0009W $0000W $0000W
              $10800D44RL   $0FA804BERL   $09DC1795RL   $3890W		

		#behaviour   collision	   tile-interaction



#############
# Berkeloid #
#############

#becomes stunned mimrock when Walking
%patch $3197C $11A2059FRL #Berkeloid
%patch $3199A $11A2059FRL #Berkeloid
%patch $319B8 $11A2059FRL #Berkeloid
%patch $319D6 $11A2059FRL #Berkeloid
#becomes stunned mimrock when Tossing flame
%patch $319F4 $11A2059FRL #Berkeloid
%patch $31A12 $11A2059FRL #Berkeloid
%patch $31A30 $11A2059FRL #Berkeloid
%patch $31A4E $11A2059FRL #Berkeloid
%patch $31A6C $11A2059FRL #Berkeloid
%patch $31A8A $11A2059FRL #Berkeloid
%patch $31AA8 $11A2059FRL #Berkeloid
%patch $31AC6 $11A2059FRL #Berkeloid
%patch $31AE4 $11A2059FRL #Berkeloid
%patch $31B02 $11A2059FRL #Berkeloid
%patch $31B20 $11A2059FRL #Berkeloid
%patch $31B3E $11A2059FRL #Berkeloid

#Slime
%patch $30F2C $11A20559RL #doesn't Kill Keen
%patch $30F4A $11A20559RL #No collision

%patch $11FAB $20A8W  #Stunned Mimrock bcomes slime
%patch $30F52 $F8 $2A # Spawn Berkeloid when vanish

#Berkeloid Bullet
%patch $10D89 $C8 $2D

#Poison slug slime (Stunned Brain) time
%patch $30F22 $008CW        #Time before half-dry

################
# Flame Bullet #
################
#Flame origin points
#%patch $10CC8 $8F $FF #Flame height (7 pixels up)

%patch $10CC8 $FF $FF #Flame height (0 pixels up)

%patch $10CFA $0000W #Left flame left position (REVERSED, 1 tile left)
%patch $10CE1 $0100W #Right flame right position (2 tiles right)

%patch $10CD0 $E4 $FF #Vertical (Up.) Flame Speed




############
# Arachnut #
############
#position
%patch $1053E $60 $FF #10 pixels up

%patch $105A9 $242CW	  #when shot recover, another shot -> stunned
%patch $31274 $1080017CRL #when shot while stunned become killed wormouth

%patch $1096A $32 $2D      #killed wormouth becomes big flame
%patch $31C18 $32 $2D	   #Big flame becomes big Flame



#################################
# Council Member now Tank Robot #
#################################
%patch $30E74 $11A20C3BRL #Produce Sprite Shot when thining; Sprite Behavior
%patch $FCFD  $05 $00 	  #Member sprite type bounder
#collision
#Walking
%patch $30E3C $10800530RL #Berkeloid
%patch $30E5A $10800530RL #Berkeloid
#Thinking
%patch $30E78 $10800530RL #Berkeloid


%patch $30E6E $0040W #Thinking Animation speed


###########
# Skypest #
###########


%patch $107BA	$2486W	    #Skypest doesn't land, just keeps on flying

#Animations Skypest flying
#Skypest has 4 flying frames 
%patch $312F6 $01BBW $01BFW $0003W $0001W $0000W $0009W $0000W $0000W
              $0FA80BE7RL   $10800530RL   $0FA80D0BRL   $24A4W
%patch $31314 $01BCW $01C0W $0003W $0001W $0000W $0009W $0000W $0000W
              $0FA80BE7RL   $10800530RL   $0FA80D0BRL   $24FEW
#Skypest preening 2+1
%patch $3136E $01BDW $01C1W $0003W $0001W $0000W $0009W $0000W $0000W
              $0FA80BE7RL   $10800530RL   $0FA80D0BRL   $24E0W
%patch $31350 $01BEW $01C2W $0003W $0001W $0000W $0009W $0000W $0000W
              $0FA80BE7RL   $10800530RL   $0FA80D0BRL   $2486W

#Change actions:
%patch $107BA $24E0W #Skypest hit ground
#%patch $10751 $251CW #When squished




#########
# Cloud #
#########
#Place Cloud in level
%patch $109FE  $28FAW #What awake cloud does (Become moving cloud)

#Lightning spawn location
%patch $10B5C $FB00W #4 tiles up
#Left distance
%patch $10B53 $00 $00 #1 Tile across

%patch $10A36 $000FW #Speed when moving
%patch $10A80 $000FW #After trying to zap Keen



#########
# Darts #
#########

#New Up-Dart behaviour $0FA800B3RL 0FB33 (Miragia 3) Cange sprite type to bounder
%patch $0FB33 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $04 $000FW  $5E $5D $CB

#Spawn Darts: 3 new actions to play 3 new sounds
%patch $129A7 $E8D0W #Spawn Dart right
%patch $12950 $E8EEW #Spawn Dart up
%patch $1298A $E90CW #Spawn Dart down

#New Dart actions, play unique sounds, goto 1st Dart actions
%patch $3D740 $0182W $0180W $0000W $0000W $0000W $0001W $0000W $0000W #Right = $E8D0W
              $0FA80C73RL   $09DC1752RL   $11A20CA1RL   $3980W
%patch $3D75E $017CW $017CW $0000W $0000W $0000W $0001W $0000W $0000W #Up = $E8EEW
              $0FA800B3RL   $00000000L    $11A20CA1RL   $39BCW
%patch $3D77C $017EW $017EW $0000W $0000W $0000W $0001W $0000W $0000W #Down = $E90CW
              $0FA80C91RL   $09DC1752RL   $11A20CA1RL   $39F8W

#Play sound behaviors 1-3 (Uses Skypest collision space, share code)
%patch $106F3 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $B8 $0029W  $EB $1C #Right =$0FA80C73RL
              $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $B8 $001EW  $EB $0D #Up =$0FA80C82RL
              $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $B8 $001DW  $50 $9A #Down =$0FA80C91RL
          $187409F1RL     $83 $C4 $02 $5E $5D $CB

#Dart gun shoot sound
%patch $129B4 $29


#Up Darts

#Speed
%patch $32838 $0000W $0010W
%patch $32856 $0000W $0010W
#collision
%patch $32840 $00000000L #not Deadly to Keen
%patch $3285E $00000000L #not Deadly to Keen

#Down dart
#speed
%patch $32874 $0000W $0030W
%patch $32892 $0000W $0030W
#spawning
%patch $128D1 $00 $00



###########
# Bounder #
###########
%patch $111BC $FFBAW #Bounder's vertical jump height
%patch $11179 $00    #How high a bounder flies into the air when shot

#Bounder collision: Lethal, shootable
%patch $11138 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09     #Check for Keen (Type 2)
             $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E $B8         #If Keen, kill him; check for shot (Type 3)
              $2F8AW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $5F $5E $5D $CB #If shot, become $2F8AW
#Sprite Type
%patch $110FE $12 $00 #Bounder
%patch $11174 $12 $00 #Shot Bounder

#Animations
#Stunned Bounder in air
%patch $31DFA $01F1W $01F1W


#############
# Blue Bird #
#############
#Walking birds (easy, medium, hard) are separate from flying birds
#Spawn points
%patch $EED1 $1A84W #'I Keen' (Easy bird)
%patch $EED3 $1A7DW #'Mom' (Normal bird)
%patch $EED5 $1A76W #'Dad' (Hard bird)


%patch $EF1D $04FBW # spawn a medium flying bird in easy

%patch $10099 $21D4W #Bluebird wait

%patch $10135 $21D4W #waiting bird becomes walking bird

#Initiation code at + $1A76
%patch $10366 $83 $3E $7A6CW  $03 $7C $19 $83 $3E $7A6CW  $02 $7C $12 $FF $76
              $FC $57 $9A $0FA808A1RL     $83 $C4 $04 $C7 $06 $5F $CB $0001W
              $E9 $EA74W

#Flying bird spawn code = $0FA808A1RL
%patch $10321 $55 $8B $EC $B8 $01 $00 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
              $1E $D8 $A7 $C7 $07 $001BW  $C7 $47 $02 $0001W  $C7 $47 $20 $0002W
                  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0
              $05 $FF1FW  $89 $47 $0C $B8 $224CW  $50 $53 $9A $09DC118CRL
              $83 $C4 $04 $5D $CB

#Stop the flying birds becoming walking birds:
%patch $103D0 $EB #Bird doesn't land when Keen is standing on ground level with it
%patch $1048B $EB #Don't land when Keen below it and Bird near ground


#Stop the walking birds flying or going to stunned bird
%patch $31026 $0173W $016FW $0000W $0000W $0001W $0078W $0080W $0000W 
#Waiting bird

              $00000000L    $10800530RL   $09DC1795RL   $21F2W
%patch $31044 $0173W $016FW $0000W $0000W $0001W $0007W $0080W $0000W 
#Walking birds

              $00000000L    $10800530RL   $09DC1795RL   $21F2W
%patch $31062 $0174W $0170W $0000W $0000W $0001W $0007W $0080W $0000W
              $00000000L    $10800530RL   $09DC1795RL   $2210W
%patch $31080 $0175W $0171W $0000W $0000W $0001W $0007W $0080W $0000W
              $00000000L    $10800530RL   $09DC1795RL   $222EW
%patch $3109E $0176W $0172W $0000W $0000W $0001W $0007W $0080W $0000W
              $10800770RL   $10800530RL   $09DC1795RL   $21D4W


#Stunned birds unstun to flying
%patch $311E6 $224CW

#Fix walking spawn height (Stop it floating in air)
%patch $1006A $FF1FW

#Walking Bird becomes dead bounder when shot
#Waiting
%patch $3103A $10800938RL 
#Walking
%patch $31058 $10800938RL #Bird
%patch $31076 $10800938RL #Bird
%patch $31094 $10800938RL #Bird
%patch $310B2 $10800938RL #Bird

#Bird unstunning

%patch $31170 $017AW $017AW
%patch $3117A $0014W        #Animation speed
%patch $3118E $017BW $017BW
%patch $31198 $0014W        #Animation speed
%patch $311AC $017AW $017AW
%patch $311B6 $0014W        #Animation speed
%patch $311CA $017BW $017BW
%patch $311D4 $0014W        #Animation speed

%patch $10058 $0000W # foreground

########
# Lick #
########
#Jumping Height
%patch $113DA $D0 $FF #Height for long hops


############
# Mimrock #
############



%patch $322D8 $11A20494RL #Mimrock look to walk

#Mimrocks always pursue Keen
#Ditch the first "Is Keen facing the Mimrock?" check
%patch $11EEB $90 $90 $90 $90 $90 $90
#Ditch the second "Is Keen facing the Mimrock?" check
%patch $11F05 $90 $90 $90 $90 $90 $90
#Don't make the Mimrock slam down if he spies Keen
%patch $11F3B $90 $90 $90 $90 $90 $90 $90 $90
#Mimrock doesn't slam back down, once activated.
%patch $3237A $58

#Sneaking Mimrock invincible
%patch $322DC $10800530RL #Mimrock
%patch $322FA $10800530RL #Mimrock
%patch $32318 $10800530RL #Mimrock
%patch $32336 $10800530RL #Mimrock
%patch $32354 $10800530RL #Mimrock
%patch $32372 $10800530RL #Mimrock
#Sitting
%patch $322BE $10800530RL 

#Jumping Mimrock becomes stunned Smirky

#Pouncing
%patch $32390 $11A20279RL #Treasure eaters
%patch $323AE $11A20279RL #Treasure eaters
%patch $323CC $11A20279RL #Treasure eaters
#Bouncing on the ground
%patch $323EA $11A20279RL #Treasure eaters


#Speed
%patch $322D4 $80 $00 #Speed 1
%patch $322F2 $80 $00 #Speed 2
%patch $32310 $80 $00 #Speed 3
%patch $32330 $80 $00 #Speed 4
%patch $3234C $80 $00 #Speed 5
%patch $3236A $80 $00 #Speed 6


#Forground behaviors
%patch $11E85 $0000W #Mimrock

#Animations
#Mimrock sitting
%patch $322AA $0193W $0184W

#Treasure eaters kill Keen, shootable (Don't get item sprites)
%patch $11C99 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $32 $C7 $44 $3E $0000W  
              $C7 $44 $40 $0000W  $C7 $44 $42 $0000W  $8B $04 $89 $44 $44 $C7 
              $04 $0021W  $57 $9A $0D8F0D43RL    $83 $C4 $02 $B8 $3386W  $50 
              $56 $9A $09DC120ARL    $83 $C4 $04 $83 $6C $18 $10 $5F $5E $5D
              $CB

################
# Mad Mushroom #
################
#Collision
%patch $30F68 $10800530RL #Berkeloid
%patch $30F86 $10800530RL #Berkeloid^

#sound
%patch $FFB0  $90 $90 $90 $90 $90 #Mad Mushroom no low bounce
%patch $FF9F  $0016W #High Bounce Sound Skypest

#jump high 
%patch $FFBB $FFEBW #Small
%patch $FF9C $FFB0W #High



##########
# Sprite #
###########
%patch $12593 $09 #Sprite type
#Sprite collision
%patch $32624 $10800C23RL #float becomes stunned lick when shot
%patch $32642 $10800C23RL #Aim
%patch $32660 $10800C23RL #Shoot
%patch $3267E $10800C23RL #Shoot
#Aim on sight
%patch $3262E $01B0W $01B2W
%patch $32638 $0005W        #Pause before returning to floating (Keen gone)

#Sprite doesn't float - short patch
%patch $125D8 $EB $2E                                    #Change action to shoot

#Sprite clipping
%patch $125A2 $0001W

#Sprite's bullet animation speed increased
%patch $32692 $0005W       #Animation speed
%patch $326B0 $0005W       #Animation speed

#Sprite's shot Actions
%patch $326A4 $3836W #Sprite's bullet 2
%patch $326C2 $3818W #Sprite's bullet 3


#######################################################
# Miragia -> Sprite's shot 2+3 -> Counsil Member exit #
#######################################################
#Spawn Miragia
#Miragia spawning code now spawning bullet now EXIT
%patch $FA80  $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0006W  $C7 $47 $02 $0001W  $C7 $47 $20 $0000W
              $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05
              $FE8FW  $89 $47 $0C $9A $1D02002ARL     $3D $0080W  $7D $0B $8B
              $1E $D8 $A7 $C7 $47 $0E $0001W  $EB $09 $8B $1E $D8 $A7 $C7 $47
              $0E $FFFFW  $8B $1E $D8 $A7 $C7 $47 $10 $0001W  $B8 $3872W  $50
              $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#Sprite's shot 
#Sprite's shot COllision 2 +3  now EXIT
%patch $326D8 $00000000L #don't Misc kill
%patch $326F6 $00000000L #don't Misc kill

#%patch $12688 $06   #Sprite's bullet
%patch $326C4 $01B6W $01B6W $0003W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L $09DC176ERL   $3872W
%patch $326E2 $01B7W $01B7W $0003W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L $09DC176ERL   $3854W

#What wins game (6 Generators)
%patch $6AE4  $7A5EW  $06 $74


#Council member text
%patch $30C17 "Emergency shutdown" $0A
              "initiated." $0A
              "... " $0A
              "... " $0A
              "Generator deactivated." $00

#Underwater council member text
%patch $30BB3 "Emergency shutdown" $0A
              "initiated." $0A
              "... " $0A
              "Orbital Generator" $0A
              "deactivated." $00

#Keen's replies:
%patch $30A71 "The way to the" $0A
              "asteroid is free!" $00
	      

%patch $30A92 "Woo-hoo!" $0A
              "Another one!" $00

#no problemo

%patch $30AC0 "Now to look for the" $0A
              "next Generator!" $0A
              " " $00

%patch $30B00 "Yeah!" $00

%patch $30B13 "Finally!" $0A
              "This is the last" $0A
              "one!" $00

%patch $30B44 "This is the last" $0A
              "one!       " $00

%patch $30B6B "Your the last one," $0A
              "fella.  Let's both" $0A
              "get back to the" $0A
              "Oracle chamber!" $00

##############
# Schoolfish #
##############

#Schoolfish sprite type

%patch $123FD $09 $00
#Schoolfish is spawns lick(bird) from an egg when shot or collision
%patch $325E8 $0FA80C57RL
%patch $32606 $0FA80C57RL

#swimming speed
%patch $12558 $0004W #Speed up
%patch $1256C $0004W #Speed down
%patch $1253C $0004W #Speed l/r


#Schoolfish clipping is 1
%patch $124E5 $0001W

#Egg caches Lick instead of Bird (Save memory)
%patch $EB0F $CB6DW 


#Flying Skypest collision, Kill Keen goto Egg collision
%patch $106D7 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $74 $03
              $E9 $F9D5W  $9A $0B8013E9RL     $5F $5E $5D $CB


#######
# Egg #
#######


#Modify Egg collision to spawn Lick and no Big shell
%patch $100CF $0012W  $C7 $44 $02 $0001W  $B8 $2FE4W $50 $56 $9A $09DC120ARL
                      $83 $C4 $04 $EB $5B 

#Tile interaction
%patch $31020 $11A20CA1RL #Up shell (Fall)
%patch $30FC6 $11A20CA1RL #Large shell (Sit)
%patch $30FE4 $11A20CA1RL #Left shell (Fall)
%patch $31002 $11A20CA1RL #Right shell (Fall)



###############
# Poison slug #
###############

%patch $30ECE $11A20C3BRL #Slug shoots bullets
%patch $FDF6 $20          #Sliming frequency
#Poison slug sliming
%patch $30EBE $0142W $013DW
%patch $30EC8 $0020W      #Sliming time


#Slug collision produces only one type of slug
%patch $FE6A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 
         $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     
         $206CW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     
         $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D 
             $CB


#extra frame after shooting; foot on map 2 $3033C -> $14B0W
%patch $30EDA $14B0W #after shoot


%patch $30320 $0142W $013DW   $0000W       $0000W     $0001W        $0008W       $0000W   $0000W
               $00000000L  $0FA803EARL  $09DC1847RL       $2012W
%patch $3032A $003CW #Animation speed






############
# wormouth #
############
%patch $10836 $EF $FF # spawn height increased

%patch $30700 $01C7W #Wormouth Cache start


#Animations Wormouth moving
#Wormouth has 2 walking frames 
%patch $3154E $01C9W $01C9W $000FW $000fW $000fW $0009W $0078W $00A0W
              $108000D4RL   $10800BFDRL     $09DC1795RL  $26C0W
%patch $31530 $01C7W $01C7W $000FW $000fW $000fW $0009W $0078W $00A0W
              $108000D4RL   $10800BFDRL     $09DC1795RL $26DEW


%patch $10931 $80 $05 #Bite range, tiles, right (+5)
%patch $10942 $00 $FB #Bite range, tiles, left  (-5)
%patch $3168A $108004A4RL #See Keen [Bite produce Flame] #Sprite Behaviors



%patch $31670 $10800BFDRL #Wormouth biting
%patch $3168E $10800BFDRL #Wormouth biting
%patch $316AC $10800BFDRL #Wormouth biting
%patch $316CA $10800BFDRL #Wormouth biting
%patch $316E8 $10800BFDRL #Wormouth biting
 

#%patch $31562 $10800BFDRL #No collision

#Looking around
%patch $31580 $10800BFDRL #Wormouth looking around
%patch $3159E $10800BFDRL #Wormouth looking around
%patch $315BC $10800BFDRL #Wormouth looking around
%patch $315DA $10800BFDRL #Wormouth looking around
%patch $315F8 $10800BFDRL #Wormouth looking around
%patch $31616 $10800BFDRL #Wormouth looking around
%patch $31634 $10800BFDRL #Wormouth looking around
%patch $31652 $10800BFDRL #No collision [Going to move]





############
# Inchworm #
############
#Cache Smirky clouds - Inchworm
%patch $EAA1 $014DW #Cloud Cache start
%patch $EAB6 $014EW #Cloud cache end

#Deadly Inchworm
%patch $31D1E $10800530RL #Inchworm 1
%patch $31D3C $10800530RL #Inchworm 2
#Inchworm moving speed
%patch $31D0A $014FW $014DW #Inchworm 1
%patch $31D14 $000EW        #Animation speed
%patch $31D28 $0150W $014EW #Inchworm 2
%patch $31D32 $000EW        #Animation speed

#Inchworm behavior code: don't seek keen
#%patch $10F70 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $1E $D6 $A7 $3B $47
#              $0A $76 $08 $C7 $44 $0E $0000W  $5E $5D $CB $C7 $44 $0E $0000W  
#              $5E $5D $CB

#Inchworm doesn't seek Keen at all
%patch $10F83 $90 $90 $90 $90 $90
%patch $10F8B $90 $90 $90 $90 $90

########
# Foot #
########

%patch $31D64 $014CW $014CW

#Spawn height:
%patch $10FD7 $0F00W #5 tiles down


#Foot location 1:
#%patch $DE43 $33
#%patch $DE58 $2f
%patch $DE43 $34
%patch $DE58 $08

#Location 2: (When exiting POTF)
#%patch $DE78 $34
#%patch $DE8C $08
%patch $DE78 $33
%patch $DE8C $2F

#Map Animation
%patch $3031E $1492W #only one frame


###########
# Lindsey #
###########


#Actions: Landsey has only 2 frames
%patch $32794 $38EAW


#Floating speeds
%patch $12829 $0000W #Floating speed
%patch $1283F $0001W #Floating u time
%patch $1284F $0001W #Floating d time

%patch $30A25 "Vorticon Grunt says:" $0A $00
%patch $30999 "There's a" $0A
              "Space Suit" $0A
              "hidden in the" $0A
              "Weaponry!" $0A $00

%patch $309FA "Thanks for the" $0A
              "clue!" $0A $00

%patch $3094C "There's a vorticon" $0A
              "car hidden in the" $0A
              "mountain." $0A $00
%patch $309E3 "Thanks!" $00

############
# Dopefish #
############
%patch $324B8 $00000000L #Produce NOT a big bubble


########
# Keen #
########
#Spacesuit
%patch $F69C $5E $5D $CB #No bubbles or sound
#Change the clipping of Keen swimming
%patch $F622  $0001W
#How Keen exits the Wow
%patch $9056 $83 $3E $A7EDW  $11 $74 $0D

#Map Keen Swimming
%patch $30348 $000AW   #Animation speed
%patch $E17B $EB $0A   #Don't play Map Keen swim 1 sound
%patch $E18A $EB $0A   #Don't play Map Keen swim 2 sound


########################
# Wetsuit - Space Suit #
########################
#Wetsuit sprite collision - don't check if Keen is in the air
%patch $12A30 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $3C $02 $75 $2B
              $C7 $06 $7A5CW  $0001W  $B8 $002DW  $50
              $9A $187409F1RL     $83 $C4 $02 $9A $0E8F0AE2RL     $9A $16540D59RL
              $C7 $06 $7A70W  $0002W  $83 $C7 $4C $5F $5E $5D $CB

#Wetsuit Text
%patch $30A4B  "Cool!  I can breathe" $0A
               "in space now!" $00

%patch $30A3D  "I can't go!" $00

###############
# level names #
###############
%patch $1F040 "Phaelox" $00

%level.name 0 Phaelox
%level.entry 0 Kylie explores\n Phaelox 

%level.name 1 Engine Room
%level.entry 1 Kylie bursts into\n the Engine Room

%level.name 2 Chemistry Lab
%level.entry 2 Kylie enters the\n Chemistry Lab

%level.name 3 Reactor Core
%level.entry 3 Kylie melts down in\n the Reactor Core

%level.name 4 Trogg Pod
%level.entry 4 Kylie drops into\n the Trogg Pod

%level.name 5 Weaponry B
%level.entry 5 Kylie shoots her way\n through the Weaponry

%level.name 6 Cratom Refinery
%level.entry 6 Kylie rolls through\n the Cratom Refinery         

%level.name 7 Swamp
%level.entry 7 Kylie trudge through\n the Swamp         

%level.name 8 Three Towers
%level.entry 8 Kylie visits the\n Three Towers

%level.name 9 Mountain
%level.entry 9 Kylie crawls into\n the Mountain

%level.name 10 Hidden Bunker
%level.entry 10 Kylie seeks the\n Hidden Bunker

%level.name 11 Volcano
%level.entry 11 Kylie burns at the\n Volcano

%level.name 12 Trogg Village
%level.entry 12 Kylie visits the\n Trogg Village

%level.name 13 The Hills
%level.entry 13 Kylie runs to\n The Hills 

%level.name 14 Secret Cloning Lab
%level.entry 14 Kylie investigates the\n Secret Cloning Lab

%level.name 15 Radar Station
%level.entry 15 Kylie scans the\n Radar Station

%level.name 16 Explorer
%level.entry 16 Kylie scouts out the\n Explorer

%level.name 17 Space Station
%level.entry 17 Kylie floats to the\n Space Station

%level.name 18 Megarocket



%patch $2F191 "Exit to Phaelox" $00

#########
# Stats #
#########

%patch $2F4CB "CRATOM" $00
#%patch $2F4D1 "Spacesuit" $00
%patch $2F49C "DISABLED" $00

#Status WINDOW - Lives
%patch $2F4C5 "KYLIE" $00

%maphead maphead.ck4 
%end